Introduction

Dovetail Search for Clarify allows agents to search Clarify data using a powerful and familiar Google-like search interface from within the Clarify Classic Client. It works in conjunction with Dovetail Seeker to provide powerful search capabilities.

Dovetail Seeker

Dovetail Seeker is the force behind Search. It's responsible for performing the actual search, and returning the search results.

Dovetail Search for Clarify

Dovetail Search provides the User Interface (UI) for searching and displaying retrieved search results from within the Clarify Classic Client. Dovetail Search for Clarify makes a request to Seeker, and Seeker returns a set of search results. Dovetail Search displays these results in a simple, intuitive format.

In This Chapter

How it works

Extensibility

Next

How it works
Introduction

Did this topic help you? Email us your feedback.
Last updated: 9/30/2010 11:20:43 AM
© by Dovetail Software, Inc.


How it works

  1. Dovetail Search makes an HTTP request to the Dovetail Seeker web application with the search terms.

    GET http://myserver/seeker/search.castle?query=lorem
  2. Dovetail Seeker responds with JSON containing the results. JSON (JavaScript Object Notation) is a lightweight data-interchange format that is easy for humans to read and write, and also easy for machines to parse and generate.

    Here's an example of a JSON response:

    {"SearchResults":[{"Score":1,"Domain":"case","Id":"7","Title":"Case with lorem ipsum in the title","Summary":"Case History"}],
    "TotalNumberOfResults":1,
    "StartResultIndex":0,
    "SearchQuery":"lorem"}
  3. Dovetail Search then parses the JSON response, and displays the results.

Architecture

The following diagram illustrates the architecture of the search components.

See Also

Introduction

Extensibility

Next

Extensibility
How it works

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:27:11 PM


Extensibility

Dovetail Seeker is extensible. Via configuration, Seeker can easily be extended to search additional (including custom) fields (such as a custom field on the case or solution), and it can also search any object in the system, including custom objects. For example, if you have a custom widget table, and want to be able to search for widgets, Seeker can handle that. Refer to the Dovetail Seeker documentation for specific details.

Dovetail Search will automatically handle most of these extensions. For example, custom fields and custom objects will work without any modifications.

The exception is opening custom objects. For example, if a custom object (such as widget) is indexed, Dovetail Search for Clarify will display these widgets in the search results – it just won't know how to open the widget form. But because Dovetail Search for Clarify ships as source code, it can be easily extended. Simply modify the ShowObject subroutine within the search form's ClearBasic code, adding support for opening your custom object. Should you need assistance with this, please contact Dovetail Software.

See Also

Introduction

How it works

Next

Upgrade Guide and New Features
Extensibility

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:03:28 PM


Upgrade Guide and New Features

In This Chapter

Version 1.1.2

Version 1.1.1

Version 1.1

Next

Version 1.1.2
Upgrade Guide and New Features

Did this topic help you? Email us your feedback.
Last updated: 9/2/2010 11:07:27 AM


Version 1.1.2

Enhancements

  • Added additional handling of exceptions returned from Dovetail Seeker (such as badly formed search queries)
  • Force Dovetail Seeker to return exceptions in JSON format (rather than HTML) by setting the "X-Requested-With" HTTP header to be "XMLHttpRequest"

Upgrading to Version 1.1.2

  1. Install the latest version of Dovetail Seeker (version 2.0.12 or higher)
  2. Recompile the 4300.cbs code file against form 4300
  3. Recompile the 4300.cbs code file against form 4303

See Also

Upgrade Guide and New Features

Version 1.1.1

Version 1.1

Next

Version 1.1.1
Version 1.1.2

Did this topic help you? Email us your feedback.
Last updated: 12/14/2010 1:12:01 PM


Version 1.1.1

Enhancements

  • Added client side validation of proper search query syntax when using wildcard (*) and (?) characters.
  • Added error handling to process responses from Seeker that are not JSON.

Upgrading to Version 1.1.1

  1. To take advantage of search enhancements, install the latest version of Dovetail Seeker (version 2.0 or higher)
  2. Recompile the 4300.cbs code file against form 4300
  3. Recompile the 4301.cbs code file against form 4301
  4. Recompile the 4302.cbs code file against form 4302
  5. Recompile the 4300.cbs code file against form 4303
  6. Recompile the search_global cbs code file

See Also

Upgrade Guide and New Features

Version 1.1.2

Version 1.1

Next

Version 1.1
Version 1.1.1

Did this topic help you? Email us your feedback.
Last updated: 12/6/2010 2:33:21 PM


Version 1.1

Enhancements

  • Dovetail Search for Clarify now handles files returned as search results. These could be attachments, such as case or solution attachments, and/or files such as product documentation. (Note: Requires Dovetail Seeker 2.0 or higher)
  • Added support for opening contacts from search results

Bug Fixes

  • Search domains that contain spaces are now wrapped in quotes.

Upgrading to Version 1.1

  1. To take advantage of search enhancements, install the latest version of Dovetail Seeker (version 2.0 or higher)
  2. Recompile the 4300.cbs code file against form 4300
  3. Recompile the 4301.cbs code file against form 4301
  4. Recompile the 4302.cbs code file against form 4302
  5. Recompile the 4300.cbs code file against form 4303
  6. Recompile the search_global cbs code file

See Also

Upgrade Guide and New Features

Version 1.1.2

Version 1.1.1

Next

Using Search
Version 1.1

Did this topic help you? Email us your feedback.
Last updated: 9/30/2010 11:26:47 AM


Using Search

In This Chapter

Menu Items

Search Forms

Next

Menu Items
Using Search

Did this topic help you? Email us your feedback.
Last updated: 10/13/2008 4:00:22 PM


Menu Items

The Search form will be opened when the user chooses the Search menu item from the Desktop menu. Multiple Search forms can be opened concurrently.

See Also

Using Search

Search Forms

Next

Search Forms
Menu Items

Did this topic help you? Email us your feedback.
Last updated: 10/13/2008 4:00:23 PM


Search Forms

See Also

Using Search

Menu Items

Next

Search Form with Summaries
Search Forms

Did this topic help you? Email us your feedback.
Last updated: 10/13/2008 4:00:23 PM


Search Form with Summaries

The Search Form allows a user to search, and shows the results of the search. This list of results include the type of object (case, solution, change request, etc.), its ID number, and its title. It also shows the first 500 characters of the summary of the object (such as the case history, solution description, etc.) Results are returned and displayed in sets (pages), with each page having 10 results.

Search Form with Summaries

See Also

Search Forms

Search Results Form without Summaries

Which Search form?

Search Tips Form

Advanced Search Form

Next

Search Results Form without Summaries
Search Form with Summaries

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:18:13 PM


Search Results Form without Summaries

This Search Form is very similar to the first, in that it allows a user to search, and shows the results of the search. This list of results include the type of object (case, solution, change request, etc.), its ID number, and its title. However, it does NOT show the summary data. This is especially useful for users with smaller monitors. Results have a page size of 10.

Search Form without Summaries

See Also

Search Forms

Search Form with Summaries

Which Search form?

Search Tips Form

Advanced Search Form

Next

Which Search form?
Search Results Form without Summaries

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:19:00 PM


Which Search form?

As discussed above, there are two Search forms – one that shows the summary information, and one that does not. By default, the Search form with the summary will be used. From there, clicking on Hide Summaries will close the default Search form, and open the Search form without summary information.

Dovetail Search for Clarify remembers which Search form was last displayed for each user. The next time a Search form is opened, it will open the same form that was last used by that user.

See Also

Search Forms

Search Form with Summaries

Search Results Form without Summaries

Search Tips Form

Advanced Search Form

Next

Search Tips Form
Which Search form?

Did this topic help you? Email us your feedback.
Last updated: 10/15/2008 11:07:00 AM


Search Tips Form

From the Search form, clicking on the Search Tips link will show the Search Tips Form. This form outlines tips and examples for using Search, including:

  • Finding results that include ALL search terms (using the AND operator)
  • Finding results that include either of multiple search terms (using the OR operator)
  • Using wildcards in searches
  • Using date ranges in searches
  • Using a property, such as the part for a case

See Also

Search Forms

Search Form with Summaries

Search Results Form without Summaries

Which Search form?

Advanced Search Form

Next

Advanced Search Form
Search Tips Form

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:19:21 PM


Advanced Search Form

From the Search form, clicking on the Advanced Search link will show the Advanced Search Form. This form assists users in building more advanced searches.

See Also

Search Forms

Search Form with Summaries

Search Results Form without Summaries

Which Search form?

Search Tips Form

Next

Installation Guide
Advanced Search Form

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:19:40 PM


Installation Guide

In This Chapter

Installation Overview

Prerequisites

Configuration

Forms

ClearBasic Code

Next

Installation Overview
Installation Guide

Did this topic help you? Email us your feedback.
Last updated: 10/15/2008 11:01:03 AM


Installation Overview

  • Install and configure Dovetail Seeker
  • Modify the Configuration File
  • Import the search_config.dat Configuration File into your database
  • Import the Forms into your database
  • Add the Forms to resource configuration(s)
  • Compile the ClearBasic Code
  • [OPTIONAL]: Install additional customization for Incorporating Search into your Case & Solution Workflow

See Also

Installation Guide

Prerequisites

Configuration

Forms

ClearBasic Code

Next

Prerequisites
Installation Overview

Did this topic help you? Email us your feedback.
Last updated: 9/30/2010 11:26:00 AM


Prerequisites

Install and configure Dovetail Seeker. Index your database using the Dovetail Seeker Indexer.

Note: Dovetail Seeker is distributed and installed separately from Dovetail Search for Clarify.

Verify that you can successfully search using SeekerConsole.exe

Example:

SeekerConsole.exe –search "searchTerm"

Verify that you can successfully access the Seeker web service. Using an Internet browser (such as Internet Explorer or Firefox), navigate to the Seeker URL, such as http://localhost/seeker. You should see the Dovetail Seeker Administration page:

If you can view the Seeker Administration page and perform a search, then Dovetail Seeker is installed and working properly.

See Also

Installation Guide

Installation Overview

Configuration

Forms

ClearBasic Code

Next

Configuration
Prerequisites

Did this topic help you? Email us your feedback.
Last updated: 12/6/2010 2:36:57 PM


Configuration

The URL to Dovetail Seeker is required for Dovetail Search to operate correctly. You can configure this parameter manually using the Clarify Client application or by importing a supplied configuration file using Clarify dataex or Dovetail ArchiveManager (DIET).

Follow the step below to configure the DovetailSeekerURL parameter using the Clarify client:

Manual Configuration

Using the Clarify client, select the 'Policies and Customers' application, followed by 'Setup' > 'Configuration Items' option from the menu.

Enter the following data as shown and click the 'Save' button:

Note: <server name> is the server where Dovetail Seeker is installed.

Alternatively, you may configure the DovetailSeekerURL parameter using a data file import:

Edit the Configuration File

The search_config.dat file contains the DovetailSeekerUrl configuration item needed by Dovetail Search. Use your favorite text editor to edit the search_config.dat file. Specifically, set the str_value property of the DovetailSeekerUrl configuration item to be the exact URL of the Dovetail Seeker web application.

Import the Configuration File

After editing the file, you must import this file into your database. Dovetail ArchiveManager (DIET) or Clarify dataex can be used to import this file.

To import this file using DIET:

diet.exe –user_name <username> -password <password> –db_server <serverName> -db_name <databaseName> -imp search_config.dat

To import this file using dataex:

dataex.exe –user_name <username> -password <password> –db_server <serverName> -db_name <databaseName> -imp search_config.dat

See Also

Installation Guide

Installation Overview

Prerequisites

Forms

ClearBasic Code

Next

Forms
Configuration

Did this topic help you? Email us your feedback.
Last updated: 12/6/2010 10:59:47 PM


Forms

The following forms are provided with Dovetail Search:

Form | Form ID | File Name
Search Form (with Summaries) | 4300 | 4300.dat
Search Tips | 4301 | 4301.dat
Advanced Search | 4302 | 4302.dat
Search Form (without Summaries) | 4303 | 4303.dat

Import the Forms

Import each form into the database using DIET or dataex.

To import a form using DIET:

diet.exe –user_name <username> -password <password. –db_server <serverName> -db_name <databaseName> -imp <formId>.dat

To import a form using dataex:

dataex.exe –user_name <username> -password <password. –db_server <serverName> -db_name <databaseName> -imp <formId>.dat

Repeat this pattern for each form.

Add the Forms to the Resource Configuration(s)

After the form files have been imported, the forms must be added to the proper resource configuration(s) using Clarify's UI Editor. You must decide which user or groups of users should see the new versions of the imported forms.

To add the forms to the resource configuration(s):

  1. Start the User Interface Editor.
  2. Choose Resource Configs… from the Select menu (File/Open resource configuration for Clarify 6.0+)
  3. Press the List button.
  4. Select the resource configuration you want to modify and press the Open button.
  5. Type dovetail1.0 in the text box to the right of the starts with dropdown list and press the List button.
  6. Select the forms you wish to add to the resource configuration from the left grid control, and press the Copy>> button.
  7. If any confirmation dialogs appear, press the OK button to continue.
  8. Press the Replace button.
  9. After the save is completed, press the Done button.
  10. Repeat steps 4-9 for any other resource configurations you wish to modify.

Exit the User Interface Editor.

See Also

Installation Guide

Installation Overview

Prerequisites

Configuration

ClearBasic Code

Next

ClearBasic Code
Forms

Did this topic help you? Email us your feedback.
Last updated: 12/6/2010 4:33:59 PM


ClearBasic Code

The supplied Clear Basic code must now be compiled against the forms you have imported.

When Clarify starts up it runs the routine 'initialize_app' (if one exists). Only one routine with this name will be run on client start-up. The module search_global.cbs contains an 'initialize_app' routine for this application. If some other custom application has a version of this routine, only one of these versions will execute. It is REQUIRED that you merge any existing version of 'initialize_app' into the version in module search_global.cbs. Then, replace the original version of 'initialize_app' with the merged version and recompile it. This will prevent the original version from overwriting the merged version if you recompile your original code, and it will ensure that all your custom applications will still be executed. Not doing this as specified may cause this application or previous customizations to function improperly.

Compile using command-line CBEX

Enter the following command to compile the ClearBasic code:

<CB Toolkit installation>\cbex.exe –dir search.cbi –batch –overwrite

where:

<CB Toolkit installation> is the path to the cbex.exe program.

Compile using GUI

You can also compile the code from the CBEX GUI. To open the CBEX GUI, double-click the CBEX.exe icon in your directory. Open search.cbi and click the import button. You can turn off the files you don't want to compile by selecting the row in the custom list, clicking the off radio button, and clicking the Replace button.

Note: Forms 4300 and 4303 use the same code file (4300).

When the compilation is completed, you should review the cbex.log file to check on the status of the compilation. There should be two rows for each file compiled that start with the word SUCCESS. If there are any failures, check the above instructions to make sure that your compilation environment is set up correctly.

See Also

Installation Guide

Installation Overview

Prerequisites

Configuration

Forms

Next

Incorporating Search into your Case & Solution Workflow
ClearBasic Code

Did this topic help you? Email us your feedback.
Last updated: 12/6/2010 3:32:18 PM


Incorporating Search into your Case & Solution Workflow

An additional customization may be made that allows Dovetail Search to be incorporated into your case and solution workflow. For example, from the Case form, clicking the Dovetail Search button will open the Search form, and can search Solutions using the case title. A solution can be opened from the Search results form, and the Link to Case button on the Solution form can be clicked, which will link the solution to the case.

This customization is entirely optional.

Case form with Dovetail Search button

In This Chapter

To Install this Customization:

Next

To Install this Customization:
Incorporating Search into your Case & Solution Workflow

Did this topic help you? Email us your feedback.
Last updated: 10/22/2008 12:22:52 PM


To Install this Customization:

The following installation instructions assume working knowledge of customizing Clarify using UI Editor and CBEX.

  1. On the case form (420 or 776), add a new button. Its name must be "dovetail_search". Its caption can be whatever you want, although "Search" or "Dovetail Search" would probably be a good idea.
  2. Merge the ClearBasic code from $dovetailSearch/ ClearBasicCode /776.cbs into the existing ClearBasic code on your case form (420 or 776), and compile.
  3. Merge the ClearBasic code from $dovetailSearch/ ClearBasicCode /321.cbs into the existing ClearBasic code on your solution form (321), and compile.
  4. Test

See Also

Incorporating Search into your Case & Solution Workflow

Next

Limitations
To Install this Customization:

Did this topic help you? Email us your feedback.
Last updated: 10/13/2008 4:00:45 PM


Limitations

  • Data Restriction of searches is not currently supported. For more information regarding Data Restriction functionality, please contact Dovetail Software.

Next

Copyright Notice and Trademarks
Limitations

Did this topic help you? Email us your feedback.
Last updated: 9/30/2010 11:19:19 AM


Copyright Notice and Trademarks

Copyright © 2010 Dovetail Software, Inc.
All rights reserved

Dovetail Software intends the information in this document solely for its licensees and to aid prospective customers in evaluating Dovetail Software products. Any other use is prohibited. Dovetail Software makes a written warranty to its licensees, as is stated in its written license agreement. Dovetail Software makes no warranty to any other party regarding the accuracy or usefulness of the information contained in this document. Dovetail Software reserves the right to modify the content of this document without obligation to notify any party. Dovetail Software is not liable for consequential or incidental damages.

Dovetail Software develops and supplies software and customizations to the following Clarify products: ClearSupport, ClearQuality, ClearHelpDesk, ClearContracts, Policies and Customers, ClearSales, ProductManager, ClearCallCenter, and ClearLogistics.

ManyDovetail Software products use the following Clarify tools: User Interface Editor, ClearBasic Exchange, Data Dictionary Editor, ClearBasic Batch, Data Exchange, Clarify Business Objects, RuleManager, eBusiness Framework, ClearBasic, and Clarify Low-Level API©.

Clarify, its product names, and tools are trademarks of Amdocs, which may include the following: ClearConfigurator, SalesBasic, ClearConfigurator Workshop, Notifier, eSupport, Classification Engine, eOrder Routing Server, eResponse Manager, ClearEnterprise, Email Clerk, Email Manager, Traveler, e.link, Diagnosis Engine, and Flexible Deployment.

Copyright Notice and Trademarks

Did this topic help you? Email us your feedback.
Last updated: 8/27/2010 2:49:53 PM


Dovetail Search for Clarify


Did this topic help you? Email us your feedback.
Last updated: 12/14/2010 1:12:35 PM


Contents Index Search